#include <bits/stdc++.h>

#define ll long long
using namespace std;

ll const mod = 1e9 + 7;

struct triple {
    ll a;
    ll b;
    ll z;
};

ll fast_pow(ll n, ll st) {
    if (st == 0) {
        return 1;
    }
    if (st == 1) {
        return n % mod;
    }
    if (st % 2 == 0) {
        ll s = fast_pow(n, st / 2) % mod;
        return (s * s) % mod;
    }
    return (fast_pow(n, st - 1) * n) % mod;
}

vector<ll> fac(200);
vector<ll> ant_fac(200);

ll c_n_k_s(ll n, ll k) {
    return (((fac[n + k - 1] * ant_fac[k]) % mod) * ant_fac[n - 1]) % mod;
}

int main() {
    ll n, m, i, j;
    cin >> n >> m;
    ll A[m];
    for (i = 0; i < m; i++) {
        cin >> A[i];
    }
    fac[1] = 1;
    ant_fac[1] = 1;
    fac[0] = 1;
    ant_fac[0] = 1;
    for(i = 2; i < 200; i++){
        fac[i] = (fac[i - 1] * i) % mod;
        ant_fac[i] = fast_pow(fac[i], mod - 2);
    }
    ll sum = 1;
    ll k = A[1];
    for (i = 1; i <= (n + k - 1) / k; i++) {
    for(j = 0; j <= n - (i - 1) * k - 1; j++ ){
        sum += c_n_k_s(i, j);
        sum %= mod;
    }
    }
    cout << sum;
}