#include <bits/stdc++.h>

#define ll long long
using namespace std;

ll const mod = 1e9 + 7;

struct triple {
    ll a;
    ll b;
    ll z;
};

ll log2(ll n) {
    ll cnt = 0;
    while (n >= 2) {
        cnt++;
        n /= 2;
    }
    return cnt;
}

ll fast_pow(ll n, ll st) {
    if (st == 0) {
        return 1;
    }
    if (st == 1) {
        return n % mod;
    }
    if (st % 2 == 0) {
        ll s = fast_pow(n, st / 2) % mod;
        return (s * s) % mod;
    }
    return (fast_pow(n, st - 1) * n) % mod;
}

int main() {
    ll n, i, j, q;
    cin >> n >> q;
    vector<vector<pair<ll, ll>>> sparse_table(log2(n) + 1);
    for(i = 0;i < sparse_table.size(); i++){
        sparse_table[i].resize(n);
    }

    ll a[n];
    ll pos[n];
    for (i = 0; i < n; i++) {
        cin >> a[i];
        sparse_table[0][i].first = a[i];
        pos[a[i] - 1] = i;
        sparse_table[0][i].second = i;
    }
    for (i = 1; i <= log2(n); i++) {
        for (j = 0; j <= n - fast_pow(2, i); j++) {
            if (sparse_table[i - 1][j].first > sparse_table[i - 1][j + fast_pow(2, i - 1)].first) {
                sparse_table[i][j].first = sparse_table[i - 1][j].first;
                sparse_table[i][j].second = sparse_table[i - 1][j].second;
            } else {
                sparse_table[i][j].first = sparse_table[i - 1][j + fast_pow(2, i - 1)].first;
                sparse_table[i][j].second = sparse_table[i - 1][j + fast_pow(2, i - 1)].second;
            }
        }
    }
    ll p, k;
    while (q--) {
        cin >> p >> k;
        p--;
        if( k == 1){
            cout << 1 << endl;
            continue;
        }
        if(k == n && p == n - 1){
            cout << 1 << endl;
            continue;
        }
        if(k == n && p == 0){
            cout << 1 << endl;
            continue;
        }
        bool idk = false;
        ll sum = 0;
        if(p - k == -1){
            ll mx = max(sparse_table[log2(p + 1)][0].first, sparse_table[(log2(p + 1))][p + 1 - fast_pow(2, log2(p + 1))].first);
            if(mx == a[p])
                sum += k - 1;
            else {
                sum += pos[mx - 1];
//////
                ll f_mx = a[p];
                ll s_mx = -1;
                if (pos[mx - 1] + 1 != p)
                    f_mx = max(sparse_table[log2(p - pos[mx - 1] - 1)][pos[mx - 1] + 1].first,
                               sparse_table[log2(p - pos[mx - 1] - 1)][pos[mx + 1] + p - pos[mx - 1] -
                                                                       fast_pow(2, log2(p - pos[mx - 1] - 1))].first);
              if(pos[mx - 1] != 0)
                    s_mx = max(sparse_table[log2(pos[mx - 1] - 1)][p - k + 1].first,
                               sparse_table[log2(pos[mx - 1] - 1)][pos[mx - 1] - fast_pow(2, log2(pos[mx - 1] - 1))].first);
              else {
                  sum++;
                  idk = true;
              }
              if (f_mx > s_mx) {
                    if (!idk)
                        sum += 1;
                    idk = true;
                }

            }
/////
        }
        if(p + k == n){
            ll mx = max(sparse_table[log2(k)][p + 1].first, sparse_table[log2(k)][n - fast_pow(2 , log2(k))].first);
            if(mx < a[p])
                sum += k - 1;
            else {
                sum += n - pos[mx - 1] - 1;
                //////
                ll f_mx = a[p];
                ll s_mx = -1;
                if (pos[mx - 1] - 1 != p)
                    f_mx = max(sparse_table[log2(pos[mx - 1] - 1 - p)][p + 1].first,
                               sparse_table[log2(pos[mx - 1] - 1 - p)][pos[mx - 1] -
                                                                       fast_pow(2, log2(pos[mx - 1] - 1 - p))].first);
                if (pos[mx - 1] != n - 1)
                    s_mx = max(sparse_table[log2(n - 1 - pos[mx - 1])][pos[mx - 1] + 1].first,
                               sparse_table[log2(n - 1 - pos[mx - 1])][n -
                                                                       fast_pow(2, log2(n - 1 - pos[mx - 1]))].first);
                else {
                    if (!idk) {
                        sum += 1;
                    }
                    idk = true;
                }

                if (f_mx > a[p + k] || s_mx > a[p + k]) {
                    if (!idk)
                        sum += 0;
                    idk = true;
                } else if (f_mx > s_mx) {
                    if (!idk)
                        sum += 1;
                    idk = true;
                } else if (!idk)
                    sum += 0;
                idk = true;
            }
            //////

        }
idk = false;
        if (k == 1) {
            if (!idk)
                sum += 1;
            idk = true;
        }
        if (p + k < n) {
            if (a[p] > a[p + k]) {
                if (!idk)
                    sum += 0;
                idk = true;
            }


            ll mx;
            mx = max(sparse_table[log2(k - 1)][p + 1].first,
                     sparse_table[log2(k - 1)][p + k - 1 - fast_pow(2, log2(k - 1))].first);
            if (mx < a[p + k]) {
                if(mx < a[p]){
                    if(!idk)
                        sum += k - 1;
                    idk = true;
                }
                if (!idk)
                    sum += p + k - pos[mx - 1] - 1;

            }

                ll f_mx = a[p];
                ll s_mx = -1;
                if (pos[mx - 1] - 1 != p)
                    f_mx = max(sparse_table[log2(pos[mx - 1] - 1 - p)][p + 1].first,
                               sparse_table[log2(pos[mx - 1] - 1 - p)][pos[mx - 1] -
                                                                       fast_pow(2, log2(pos[mx - 1] - 1 - p))].first);
                if (p + k - pos[mx - 1] != 1)
                    s_mx = max(sparse_table[log2(k + p - pos[mx - 1] - 1)][pos[mx - 1] + 1].first,
                               sparse_table[log2(k + p - pos[mx - 1] - 1)][p + k - fast_pow(2, log2(k + p -
                                                                                                    pos[mx - 1] -
                                                                                                    1))].first);
                if (f_mx > a[p + k] || s_mx > a[p + k]) {
                    if (!idk)
                        sum += 0;
                    idk = true;
                } else if (f_mx > s_mx) {
                    if (!idk)
                        sum += 1;
                    idk = true;
                } else if (!idk)
                    sum += 0;
                idk = true;

        }
        idk = false;
        if (p - k >= 0) {
            if (a[p] > a[p - k]) {
                if (!idk)
                    sum += 0;
                idk = true;
            }

            ll mx;
            mx = max(sparse_table[log2(k - 1)][p - k + 1].first,
                     sparse_table[log2(k - 1)][p - fast_pow(2, log2(k - 1))].first);
            if (mx < a[p - k]) {
                if(mx < a[p]){
                    if(!idk)
                        sum += k - 1;
                    idk = true;
                }
                if (!idk)
                    sum += pos[mx - 1] - 1 - p + k;

            }

                ll f_mx = a[p];
                ll s_mx = -1;
                if (pos[mx - 1] + 1 != p)
                    f_mx = max(sparse_table[log2(p - pos[mx - 1] - 1)][pos[mx - 1] + 1].first,
                               sparse_table[log2(p - pos[mx - 1] - 1)][pos[mx + 1] + p - pos[mx - 1] -
                                                                       fast_pow(2, log2(p - pos[mx - 1] - 1))].first);
                if (p - k + 1 != pos[mx - 1])
                    s_mx = max(sparse_table[log2(pos[mx - 1] - p + k - 1)][p - k + 1].first,
                               sparse_table[log2(pos[mx - 1] - p + k - 1)][pos[mx - 1] - fast_pow(2, log2(pos[mx - 1] - p + k - 1))].first);
                if (f_mx > a[p - k] || s_mx > a[p - k]) {
                    if (!idk)
                        sum += 0;
                    idk = true;
                } else if (f_mx > s_mx) {
                    if (!idk)
                        sum += 1;
                    idk = true;
                } else if (!idk)
                    sum += 0;
                idk = true;

        }
        cout << sum << endl;
    }
}